
/*

  here it goes...

*/

#include <stdio.h>
#include <string.h>
#include <windows.h>

#include <string>

#include "cps2romspace.h"
#include "cps2charset.h"
#include "gui.h"
#include "roms.h"

extern tGui* gui;
extern tRomSet romsetList[];


// constructor

cps2romspace::cps2romspace()
{
	// zero point roms

	romCPU1=0;
	romCPU2=0;

	romqsound=0;
}

// destructor

cps2romspace::~cps2romspace()
{
	if (romCPU1!=0) delete [] romCPU1;
	if (romCPU2!=0) delete [] romCPU2;

	if (romqsound!=0) delete [] romqsound;
}

int cps2romspace::readRoms(char* path,char* romsetname,tCharset** chs)
{
	int err;
	int rs;
	long int i,j;
	unsigned char* temprom;
	char fullname[1024];
	tRomSet* rsp;

	err=romsetByName(romsetname,&rs);
	if (err!=0)
	{
		return 1;
	}

	rsp=&romsetList[rs];

	//
	// read main cpu roms
	// (68000)
	//

	temprom=new unsigned char [0x400000];
	romCPU1=new unsigned char [0x800000];

	memset(romCPU1,0,0x800000);

	for (i=0;i<rsp->ncoderoms;i++)
	{
		// load rom into temprom

		strcpy(fullname,path);
		strcat(fullname,rsp->romlist[i].romset);
		strcat(fullname,".zip");

		err=loadZippedRom(fullname,
						  rsp->romlist[i].name,
						  rsp->romlist[i].size,
						  rsp->romlist[i].crc32,
						  temprom);
		if (err!=0)
		{
			gui->printMessage(". Unable to load code rom");
			return 1;
		}

		// type of rom?

		if (rsp->romlist[i].loadtype==ROM_LOAD_ODD)
		{
			for (j=0;j<rsp->romlist[i].size;j++)
			{
				romCPU1[rsp->romlist[i].position+j*2+1]=temprom[j];
			}
		}
		else if (rsp->romlist[i].loadtype==ROM_LOAD_EVEN)
		{
			for (j=0;j<rsp->romlist[i].size;j++)
			{
				romCPU1[rsp->romlist[i].position+j*2]=temprom[j];
			}
		}
		else if (rsp->romlist[i].loadtype==ROM_LOAD_WIDESWAP)
		{
 			memcpy(romCPU1+rsp->romlist[i].position,
				   temprom,
				   rsp->romlist[i].size);			
		}
		else
		{
			gui->printMessage(".Invalid rom load format");
			return 1;
		}
	}

	//
	// read the graphic roms
	//

	// delete previous charsets

	if (*chs!=0) delete *chs;
	*chs=new cps2charset(rsp->nspr,rsp->nchars,rsp->ntile16,rsp->ntile32);

	// calculate and store 
	// total size of graphic roms

	tCharset* pchs=*chs;

	gromsize=getGromSize(rsp);

	pchs->gfxrom=new unsigned char [gromsize];

	for (i=rsp->ncoderoms;i<(rsp->ncoderoms+rsp->ngfxroms);i++)
	{
		strcpy(fullname,path);
		strcat(fullname,rsp->romlist[i].romset);
		strcat(fullname,".zip");

		if (rsp->romlist[i].loadtype==ROM_LOAD_NORMAL)
		{
			err=loadZippedRom(fullname,
							  rsp->romlist[i].name,
							  rsp->romlist[i].size,
							  rsp->romlist[i].crc32,
							  pchs->gfxrom+rsp->romlist[i].position);
			if (err!=0)
			{
				gui->printMessage(".Unable to load graphic rom");
				return 1;
			}
		}
		else if (rsp->romlist[i].loadtype==ROM_LOAD_SKIP6)
		{
			err=loadZippedRom(fullname,
							  rsp->romlist[i].name,
							  rsp->romlist[i].size,
							  rsp->romlist[i].crc32,
							  temprom);
			if (err!=0)
			{
				gui->printMessage(".Unable to load graphic rom");
				return 1;
			}

			// load words skipping 6 bytes
			
			for (int p=0;p<(rsp->romlist[i].size);p+=2)
			{
				pchs->gfxrom[rsp->romlist[i].position+(p/2)*8]=  temprom[p];
				pchs->gfxrom[rsp->romlist[i].position+(p/2)*8+1]=temprom[p+1];
			}
		}
	}

	//
	// read sound roms
	//

	// z80
	romCPU2=new unsigned char [0x40000];

	if (rsp->nsndcoderoms>0)
	{
		for (i=rsp->ncoderoms+rsp->ngfxroms;i<rsp->ncoderoms+rsp->ngfxroms+rsp->nsndcoderoms;i++)
		{
			strcpy(fullname,path);
			strcat(fullname,rsp->romlist[i].romset);
			strcat(fullname,".zip");

			err=loadZippedRom(fullname,
							  rsp->romlist[i].name,
							  rsp->romlist[i].size,
							  rsp->romlist[i].crc32,
							  romCPU2+rsp->romlist[i].position);

			if (err!=0)
			{
				gui->printMessage(". Unable to load z80 sound rom");
				return 1;
			}
		}
	}

	// qsound samples

	romqsound=new unsigned char [0x800000];

	if (rsp->nsndsampleroms>0)
	{
		int frm=rsp->ncoderoms+rsp->ngfxroms+rsp->nsndcoderoms;
		int to=rsp->ncoderoms+rsp->ngfxroms+rsp->nsndcoderoms+rsp->nsndsampleroms;

		for (i=frm;i<to;i++)
		{
			strcpy(fullname,path);
			strcat(fullname,rsp->romlist[i].romset);
			strcat(fullname,".zip");

			err=loadZippedRom(fullname,
							  rsp->romlist[i].name,
							  rsp->romlist[i].size,
							  rsp->romlist[i].crc32,
							  temprom);

			if (rsp->romlist[i].loadtype==ROM_LOAD_BYTESWAP)
			{
				for (int j=0;j<rsp->romlist[i].size;j+=2)
				{
					unsigned char temp=temprom[j];
					temprom[j]=temprom[j+1];
					temprom[j+1]=temp;
				}
			}

			memcpy(&romqsound[rsp->romlist[i].position],
				   temprom,rsp->romlist[i].size);

			if (err!=0)
			{
				gui->printMessage(". Unable to load 1st qsound sample rom");
				return 1;
			}
		}
	}

	// store emulation related data

	strcpy(romname,rsp->name);
	kludge=rsp->kludge;
	orientation=rsp->orientation;
	romsettype=rsp->romsettype;
	nspr=rsp->nspr;
	nchars=rsp->nchars;
	ntile16=rsp->ntile16;
	ntile32=rsp->ntile32;

	sprmagic1=rsp->sprmagic1; sprmagic2=rsp->sprmagic2;
	charmagic1=rsp->charmagic1;
	tile16magic1=rsp->tile16magic1; tile16magic2=rsp->tile16magic2; 
	tile32magic1=rsp->tile32magic1; tile32magic2=rsp->tile32magic2; 

	sproffs=rsp->sproffs;
	charoffs=rsp->charoffs;
	tile16offs=rsp->tile16offs;
	tile32offs=rsp->tile32offs;

	charbase=rsp->charbase;
	tile16base=rsp->tile16base;
	tile32base=rsp->tile32base;

	charpad=rsp->charpad;
	tile16pad=rsp->tile16pad;
	tile32pad=rsp->tile32pad;

	protport=rsp->protport;
	protval=rsp->protval;
	multlo=rsp->multlo;
	multhi=rsp->multhi;
	fac1=rsp->fac1;
	fac2=rsp->fac2;
	layercontrol=rsp->layercontrol;

	// free space

	delete [] temprom;

	return 0;
}

// CPS-2 (makes always cool to write it)

void cps2romspace::cps1_gfx_decode(unsigned char* gRom)
{
	int size=gromsize;
	int i,j,gfxsize;
	unsigned char *cps1_gfx = gRom;


	gfxsize=gromsize/4;

	for (i = 0;i < gfxsize;i++)
	{
		unsigned long int src = cps1_gfx[4*i] + (cps1_gfx[4*i+1]<<8) + (cps1_gfx[4*i+2]<<16) + (cps1_gfx[4*i+3]<<24);
		unsigned long int dwval = 0;

		for (j = 0;j < 8;j++)
		{
			int n = 0;
			unsigned long int mask = (0x80808080 >> j) & src;

			if (mask & 0x000000ff) n |= 1;
			if (mask & 0x0000ff00) n |= 2;
			if (mask & 0x00ff0000) n |= 4;
			if (mask & 0xff000000) n |= 8;

			dwval |= n << (j * 4);
		}
		cps1_gfx[4*i  ] = dwval>>0;
		cps1_gfx[4*i+1] = dwval>>8;
		cps1_gfx[4*i+2] = dwval>>16;
		cps1_gfx[4*i+3] = dwval>>24;
	}
}


//

void cps2romspace::unshuffle(__int64 *buf,int len)
{
	int i;
	__int64 t;

	if (len == 2) return;

	if (len % 4) return;   /* must not happen */

	len /= 2;

	unshuffle(buf,len);
	unshuffle(buf + len,len);

	for (i = 0;i < len/2;i++)
	{
		t = buf[len/2 + i];
		buf[len/2 + i] = buf[len + i];
		buf[len + i] = t;
	}
}

//

void cps2romspace::decodeCharset(tCharset* chset)
{
	for (int i = 0;i < gromsize;i += 0x200000)
	{
		unshuffle((__int64 *)(chset->gfxrom + i),0x200000/8);
	}

	cps1_gfx_decode(chset->gfxrom);

	chset->sproffs=sproffs;
	chset->charoffs=charoffs;
	chset->tile16offs=tile16offs;
	chset->tile32offs=tile32offs;
}